from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore.utils import getToolByName
from StringIO import StringIO
from Products.CMFCore.CMFCorePermissions import setDefaultRoles
from Products.SimpleVocabularies.Permissions import MANAGE_VOCABULARIES
from Products.SimpleVocabularies import GLOBALS

from Products.ProxyIndex import ProxyIndex


def install(self):

    out = StringIO()

    install_subskin(self, out, GLOBALS)

    portal = getToolByName(self,'portal_url').getPortalObject()

    if not hasattr(self, 'portal_vocabularies'):
        addTool = portal.manage_addProduct['SimpleVocabularies'].manage_addTool
        addTool(type='SimpleVocabularies tool')    

        
    # register 2.0 control panel
    cp=self.portal_controlpanel
    cp.addAction(id='SimpleVocabularies',
                 name='Portal vocabularies',
                 action='string:${portal_url}/simplevocabularies_managePortalVocabs',
                 permission='Manage portal',
                 category='Products',
                 appId='SimpleVocabularies',
                 imageUrl='SimpleVocabularies/simplevocabularies_icon.gif',
                 description='Define and manage portal vocabularies')

    # create the action
    at=getToolByName(self, 'portal_actions')
    
    if 'vocabularies' not in [action.id for action in at.listActions()]:
        
        at.addAction('vocabularies','Vocabularies','string:${object_url}/simplevocabularies_manageObjectVocabs','',MANAGE_VOCABULARIES,'object')
    
        
    # add the proxy indexes
    pc = getToolByName(self, 'portal_catalog')
    d = ProxyIndex.RecordStyle()
    d['idx_type']='FieldIndex'
    d['value_expr']='python: object.portal_vocabularies.hasVocabularyCustomizations(object)'
    d['idx_context']=pc    
    pc.addIndex('hasVocubularyCustomizations', ProxyIndex.ProxyIndex.meta_type, d)
    
    d = ProxyIndex.RecordStyle()
    d['idx_type']='KeywordIndex'
    d['value_expr']='python: object.portal_vocabularies.getLocalVocabularyNames(object)'
    d['idx_context']=pc    
    pc.addIndex('vocabulary_customizations', ProxyIndex.ProxyIndex.meta_type, d)

    
    print >> out, "Successfully installed SimpleVocabularies"
    return out.getvalue()

            
def uninstall(self):
    #remove configlet
    try:
        self.portal_controlpanel.unregisterApplication('SimpleVocabularies')
    except:
        pass
    
    # remove indexes    
    try:
        pc = getToolByName(self, 'portal_catalog')
        pc.delIndex('hasVocubularyCustomizations')
        pc.delIndex('vocabulary_customizations')
    except:
        pass
    
    